Attribute VB_Name = "znum_gen1"
'///////////////////////////////////////////////////////////////////////////////////
'/
'/  Projekt : Nummerngenerator fr SolidWorks
'/  Modul   : wp_SolidWorks
'/
'/  10.01.2011, Klaus Riesmeier, Norbert Wagner, Wemhner Surface Technologies GmbH & Co.KG
'/
'///////////////////////////////////////////////////////////////////////////////////

Option Explicit

Const swCustomInfoText = 30

' Konstanten fr die Abfrage, was in SWX gerade offen ist. Wird von swxTyp verwendet
Const swDocPART = 1
Const swDocASSEMBLY = 2
Const swDocDRAWING = 3
Const swDocLIB = 4
Const swDocWeldment = 5
Const PDMWorksPfad = "C:\PDMWorks\"

Public ZEICHNUNGS_DIN_NR As String

Dim swApp               As Object
Dim swConfigMgr         As Object
Dim swCustPropMgr       As Object
Dim swModel             As Object
Dim swSelMgr            As Object
Dim swComponent         As Object
Dim swComp              As Object
Dim swCompModel         As Object
Dim swSelCount          As Integer
Dim Pfadkomplett        As String
Dim nErrors             As Long
Dim nWarnings           As Long
Dim nRetval             As Long
Dim bShowMap            As Boolean
Dim bRet                As Boolean
Dim ConfName            As String
Dim index               As String
Dim swxTyp              As Integer
Dim endung              As String
Dim compName            As String
Dim bgname              As String


Sub znumgen()


  Set swApp = CreateObject("SldWorks.Application")
  Set swModel = swApp.ActiveDoc
    
  ' Wenn keine Zeichnung auf ist, dann Abbruch
  If swModel Is Nothing Then Exit Sub
    
  swxTyp = swModel.GetType
    
  Select Case swxTyp
     Case swDocASSEMBLY
        endung = ".sldasm"
     Case swDocPART
        endung = ".sldprt"
     Case swDocDRAWING
        endung = ".slddrw"
  End Select ' Case swxTyp
    
  Set swConfigMgr = swModel.ConfigurationManager
  Set swCustPropMgr = swModel.Extension.CustomPropertyManager("")
  ZEICHNUNGS_DIN_NR = neueWDNr()
  'ZEICHNUNGS_DIN_NR = "WD-123456789"
  
  Pfadkomplett = PDMWorksPfad & ZEICHNUNGS_DIN_NR & endung
  'Debug.Print Pfadkomplett
  swAddInfo
  delProps.delProps
  
  bRet = swModel.SaveAs4(Pfadkomplett, swSaveAsCurrentVersion, swSaveAsOptions_Silent, nErrors, nWarnings)
  If bRet = False Then
     nRetval = swApp.SendMsgToUser2("Probleme mit dem Speichern", swMbWarning, swMbOk)
  End If
    
  '# Abrumen
  If Not swConfigMgr Is Nothing Then Set swConfigMgr = Nothing
  If Not swCustPropMgr Is Nothing Then Set swCustPropMgr = Nothing
  If Not swModel Is Nothing Then Set swModel = Nothing
  If Not swSelMgr Is Nothing Then Set swSelMgr = Nothing
  If Not swApp Is Nothing Then Set swApp = Nothing

End Sub

' --------------------------------------------------------------------
' swAddInfo()
' --------------------------------------------------------------------
Sub swAddInfo()
    swCustPropMgr.Delete "ZEICHNUNGS_DIN_NR"
    swCustPropMgr.Add2 "ZEICHNUNGS_DIN_NR", swCustomInfoText, ZEICHNUNGS_DIN_NR
End Sub


Sub znumgen_bg()
  Set swApp = CreateObject("SldWorks.Application")
  Set swModel = swApp.ActiveDoc
    
  'ZEICHNUNGS_DIN_NR = "WD-123456789"
  ZEICHNUNGS_DIN_NR = neueWDNr()
  ' Wenn keine Zeichnung auf ist, dann Abbruch
  If swModel Is Nothing Then Exit Sub
    
  swxTyp = swModel.GetType
  Set swSelMgr = swModel.SelectionManager
  swSelCount = swSelMgr.GetSelectedObjectCount2(0)
    
  If swxTyp = swDocASSEMBLY And swSelCount = 1 Then
    Set swComp = swSelMgr.GetSelectedObject6(1, 0)
    If swComp.IsVirtual = True Then
      Debug.Print "eine virtuelle Komponente " & swComp.Name2 & " ausgewhlt"
        bgname = Left(swModel.GetTitle, Len(swModel.GetTitle) - 7)
        Dim objFSO As Object
        Dim objFile As Object

        Set objFSO = CreateObject("Scripting.FileSystemObject")
        Set objFile = objFSO.GetFile(swModel.GetPathName)

        compName = objFSO.GetParentFolderName(objFile) & "\" & ZEICHNUNGS_DIN_NR

        If swComp.GetModelDoc2.GetType = swDocPART Then
            compName = compName & ".sldprt"
        Else
            compName = compName & ".sldasm"
        End If

        'Debug.Print "Name of saved virtual component: " & compName
        'swComp.SaveVirtualComponent compName
        swComp.Name2 = ZEICHNUNGS_DIN_NR & "^" & bgname
        ' Debug.Print ZEICHNUNGS_DIN_NR & "^" & bgname
        Set swCompModel = swApp.ActivateDoc2(swComp.GetPathName, True, nRetval)
        Set swModel = swApp.ActiveDoc
        Set swConfigMgr = swModel.ConfigurationManager
        Set swCustPropMgr = swModel.Extension.CustomPropertyManager("")
        
        swAddInfo
        swModel.SetSaveFlag
        swApp.CloseDoc swModel.GetTitle
        If swApp.ActiveDoc.EditRebuild3() Then
           'MsgBox "Rebuild successful"
        Else
            MsgBox "Wiederaufbaufehler"
        End If
    End If
  End If
   
  '# Abrumen
  If Not swConfigMgr Is Nothing Then Set swConfigMgr = Nothing
  If Not swCustPropMgr Is Nothing Then Set swCustPropMgr = Nothing
  If Not swModel Is Nothing Then Set swModel = Nothing
  If Not swSelMgr Is Nothing Then Set swSelMgr = Nothing
  If Not swApp Is Nothing Then Set swApp = Nothing
  If Not objFSO Is Nothing Then Set objFSO = Nothing
  If Not objFile Is Nothing Then Set objFile = Nothing

End Sub
